<template lang="pug">

section.product(v-if='product.active')
  h1.main-heading_inner.container.product__heading {{ product.name }}

  el-breadcrumb.mb-20.container(separator-class='el-icon-arrow-right')
    el-breadcrumb-item(:to="{ path: '/' }") Главная
    el-breadcrumb-item(:to="{ path: '/catalog' }") Каталог товаров
    el-breadcrumb-item(
      v-if="currentCategory"
      :to="{ path: `/catalog/${currentCategory.slug}` }") {{ currentCategory.name }}
    el-breadcrumb-item {{ product.name }}

  .product__content-wrapper
    .product__image-wrapper
      .product__image
        app-image-item(
          :source="product.photo"
          :alt="product.name")
    .product__text-wrapper
      .product__description.quill(v-html="product.description")
      .product__energy-block
        h4.product__energy-heading(v-if="product.squirrels || product.fat || product.carbohydrates || product.energy")
          | Пищевая ценность 100г продукта:
        .product__energy-wrapper(v-if="product.squirrels || product.fat || product.carbohydrates || product.energy")
          .product__energy-item(v-if="product.squirrels")
            span.product__energy-value {{ product.squirrels }}
            span.product__energy-name Белки
          .product__energy-item(v-if="product.fat")
            span.product__energy-value {{ product.fat }}
            span.product__energy-name Жиры
          .product__energy-item(v-if="product.carbohydrates")
            span.product__energy-value {{ product.carbohydrates }}
            span.product__energy-name Углеводы
          .product__energy-item(v-if="product.energy")
            span.product__energy-value {{ product.energy }}
            span.product__energy-name Энергетическая ценность
      hr
      p.product__composition
        b Состав:&nbsp;
        span {{ product.composition }}

</template>

<script>
import { mapGetters, mapMutations } from 'vuex';
import ImageItem from '../../../components/public/ImageItem';

export default {
  name: 'ProductItem',
  components: {
    'app-image-item': ImageItem
  },
  head() {
    return {
      title: `${this.product.name} | АО «Шувалово»`
    };
  },
  async asyncData(context) {
    let { data } = await context.$axios.get(
      `/api/v1/products/slug/${context.params.slug}`
    );
    return { product: data };
  },
  computed: {
    ...mapGetters({
      categories: 'CATEGORIES'
    }),
    currentCategory() {
      return this.categories
        ? this.categories.filter(item => item.slug === this.product.category)[0]
        : null;
    }
  },
  mounted() {
    if (!this.categories) {
      this.getCategories();
    }
    this.SET_LOADING(false);
  },
  created() {
    if (!this.product.active) {
      this.$router.push('/catalog');
    }
  },
  methods: {
    ...mapMutations(['SET_CATEGORIES', 'SET_LOADING']),
    getCategories() {
      this.$axios.get('/api/v1/categories/public').then(data => {
        this.SET_CATEGORIES(data.data);
      });
    }
  }
};
</script>

<style scoped>
</style>
